// shelljs 执行 rm/cp/mkdir 等文件命令操作
require('shelljs/global')

var env = process.env.NODE_ENV
var path = require('path')
var config = require('../config')
var webpack = require('webpack')
var webpackConfig = require('./prod.conf.js')

// 主要用来实现node.js命令行环境的loading效果，和显示各种状态的图标等
var ora = require('ora')
var spinner = ora('building for production...')
spinner.start()

//1、 把static资源 cp 到 dist/static 中。
var assetsPath = path.join(config.build.assetsRoot, config.build.assetsSubDirectory)
rm('-rf', assetsPath)
mkdir('-p', assetsPath)
cp('-R', 'static/*', assetsPath)

//2、 src 打包到 dist
webpack(webpackConfig, function(err, stats) {
    spinner.stop()
    if (err) throw err
    process.stdout.write(stats.toString({
        colors: true,
        modules: false,
        children: false,
        chunks: false,
        chunkModules: false
    }) + '\n')
})